%if 0%{?fedora}
%global with_python3 1
%else
%{!?python2_sitelib: %global python2_sitelib %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")}
%endif

# For use when building for a new python2/3 and python-jaraco-collections is
# not yet built.  Turn this on, build both python-jaraco-text and
# python-jaraco-collections.  Turn this off rebuild the package.
%global with_bootstrap 0

%global srcname jaraco-collections
%global upstreamname jaraco.collections

Name:           python-jaraco-collections
Version:        1.3.1
Release:        3%{?dist}
Summary:        Models and classes to supplement the python stdlib collections

License:        MIT
URL:            https://pypi.python.org/pypi/%{upstreamname}/
Source0:        https://pypi.python.org/packages/source/j/%{upstreamname}/%{upstreamname}-%{version}.tar.gz

BuildArch:      noarch

Provides: python2-%{srcname} = %{version}-%{release}

Requires: python-six
Requires: python-jaraco-classes
Requires: python-jaraco-text
BuildRequires: python2-devel
BuildRequires: python-setuptools
BuildRequires: python2-setuptools_scm
BuildRequires: python-sphinx
BuildRequires: pytest >= 2.8
BuildRequires: python-pytest-runner
BuildRequires: python-six
BuildRequires: python-jaraco-classes
%if !0%{?with_bootstrap}
BuildRequires: python-jaraco-text
%endif

%if 0%{?with_python3}
BuildRequires: python3-devel
BuildRequires: python3-setuptools
BuildRequires: python3-setuptools_scm
BuildRequires: python-sphinx
BuildRequires: python3-pytest >= 2.8
BuildRequires: python-pytest-runner
BuildRequires: python3-six
BuildRequires: python3-jaraco-classes
%if !0%{?with_bootstrap}
BuildRequires: python3-jaraco-text
%endif
%endif

%description
jaraco.collections contains a number of python classes implementing various
containers.

%if 0%{?with_python3}
%package -n python3-%{srcname}
Summary: Models and classes to supplement the python3 stdlib collections
Requires: python3-six
Requires: python3-jaraco-text
Requires: python3-jaraco-classes

%description -n python3-%{srcname}
jaraco.collections contains a number of python classes implementing various
containers.

This package contains the version of the module designed to work with python3
%endif

%prep
%setup -q -n %{upstreamname}-%{version}

%if 0%{?with_python3}
rm -rf %{py3dir}
cp -a . %{py3dir}
%endif

%build
%{__python2} setup.py build
%{__python2} setup.py build_sphinx

%if 0%{?with_python3}
pushd %{py3dir}
%{__python3} setup.py build
popd
%endif

%install
rm -rf %{buildroot}
%{__python2} setup.py install --skip-build --root %{buildroot}

%if 0%{?with_python3}
pushd %{py3dir}
%{__python3} setup.py install --skip-build --root %{buildroot}
popd
%endif
%check
%if !0%{?with_bootstrap}

# py.test is raising ImportMismatchError
# something to do with it finding the system installed package as well as the
# module we're trying to build.  Ugly hack to work around that
#{__python2} setup.py test
mv jaraco j
py.test
mv j jaraco

%if 0%{?with_python3}
pushd %{py3dir}
# py.test is raising ImportMismatchError
# something to do with it finding the system installed package as well as the
# module we're trying to build.  Ugly hack to work around that
#{__python3} setup.py test
mv jaraco j
py.test-3
mv j jaraco
popd
%endif # with_python3

%endif # with_bootstrap

%files
%doc README.txt CHANGES.txt docs
%{python2_sitelib}/*

%if 0%{?with_python3}
%files -n python3-%{srcname}
%doc README.txt CHANGES.txt docs
%{python3_sitelib}/*
%endif

%changelog
* Fri Jan 22 2016 Toshio Kuratomi <toshio@fedoraproject.org> - 1.3.1-3
- Build html docs

* Fri Jan 22 2016 Toshio Kuratomi <toshio@fedoraproject.org> - 1.3.1-2
- Remove bootstrapping so the tests can run
- Ugly ugly hack to run the testsuite.  Seems to be a problem with pytest?

* Fri Jan 22 2016 Toshio Kuratomi <toshio@fedoraproject.org> - 1.3.1-2
- Initial Fedora build
